## facter 3.14.12

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2.2)
project(FACTER VERSION 3.14.12)

# Set this early, so it's available. AIX gets weird, man.
if("${CMAKE_SYSTEM_NAME}" MATCHES "AIX")
    set(AIX TRUE)
endif()

if (NOT CMAKE_BUILD_TYPE)
    message(STATUS "Defaulting to a release build.")
    set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif()

include(CheckIncludeFile)
CHECK_INCLUDE_FILE(utmpx.h HAVE_UTMPX_H -DHAVE_UTMPX_H)

option(YAMLCPP_STATIC "Use yaml-cpp's static libraries" OFF)
option(BUILD_SHARED_LIBS "Build libfacter as a shared library" ON)

set(FACTER_PATH "" CACHE PATH "Specify the location to look for specific binaries before trying PATH.")
if (FACTER_PATH)
    # Specify a preferred location for binary lookup that will be prioritized over PATH.
    file(TO_CMAKE_PATH ${FACTER_PATH} FACTER_PATH_FIXED)
    add_definitions(-DFACTER_PATH="${FACTER_PATH_FIXED}")
    message(STATUS "Prioritizing binary lookup in ${FACTER_PATH_FIXED}")
endif()

set(FACTER_RUBY "" CACHE FILEPATH "Specify the location of libruby at compile-time, bypassing dynamic lookup.")
if (FACTER_RUBY)
    file(TO_CMAKE_PATH ${FACTER_RUBY} FACTER_RUBY_PATH)
    add_definitions(-DFACTER_RUBY="${FACTER_RUBY_PATH}")
    message(STATUS "Fixing lookup for libruby to ${FACTER_RUBY_PATH}")
endif()

set(AIO_AGENT_VERSION "" CACHE STRING "Creates an aio_agent_version fact with the specified value.")
if (AIO_AGENT_VERSION)
    add_definitions(-DAIO_AGENT_VERSION="${AIO_AGENT_VERSION}")
    message(STATUS "Adding fact aio_agent_version=${AIO_AGENT_VERSION}")
endif()

enable_testing()

list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

if ("${CMAKE_SYSTEM_NAME}" MATCHES "Darwin")
    # Allow searching in boxen installed homebrew directories
    # http://stackoverflow.com/questions/1487752/how-do-i-instruct-cmake-to-look-for-libraries-installed-by-macports
    set(CMAKE_LIBRARY_PATH ${CMAKE_LIBRARY_PATH} /opt/boxen/homebrew/lib)
    set(CMAKE_INCLUDE_PATH ${CMAKE_INCLUDE_PATH} /opt/boxen/homebrew/include)
endif()

include(FeatureSummary)

SET(LEATHERMAN_COMPONENTS locale catch nowide logging util file_util dynamic_library execution ruby rapidjson)

# We look for curl early, because whether or not we link to the leatherman curl library
# is dependant on whether or not we find curl on the system.
if ((("${CMAKE_SYSTEM_NAME}" MATCHES "FreeBSD|Linux|OpenBSD") OR WIN32) AND NOT WITHOUT_CURL)
    find_package(CURL)
    if (CURL_FOUND)
        add_definitions(-DUSE_CURL)
        list(APPEND LEATHERMAN_COMPONENTS curl)
    endif()
    set_package_properties(CURL PROPERTIES DESCRIPTION "A free and easy-to-use client-side URL transfer library" URL "http://curl.haxx.se/libcurl/")
    set_package_properties(CURL PROPERTIES TYPE OPTIONAL PURPOSE "Enables facts that require HTTP.")
endif()

if (WIN32)
    list(APPEND LEATHERMAN_COMPONENTS windows)
endif()

find_package(Leatherman REQUIRED COMPONENTS ${LEATHERMAN_COMPONENTS})

# Now that we have leatherman, we can pulll in its options file, which
# we need for finding all our other libraries.
include(options)

if (LEATHERMAN_USE_LOCALES)
    add_definitions(-DLEATHERMAN_I18N)
    SET(BOOST_COMPONENTS locale)
endif()

# We use program_options, system, filesystem, date_time, and regex directly. Testing uses thread and chrono.
list(APPEND BOOST_COMPONENTS program_options system filesystem date_time regex thread chrono)

find_package(Boost 1.54 REQUIRED COMPONENTS ${BOOST_COMPONENTS})
# date_time and regex need threads on some platforms, and find_package Boost only includes
# pthreads if you require the Boost.Thread component.
find_package(Threads)

find_package(Ruby 1.9)

find_package(YAMLCPP REQUIRED)
if (NOT WITHOUT_OPENSSL)
    find_package(OPENSSL)
endif()
if ("${CMAKE_SYSTEM_NAME}" MATCHES "Linux" AND NOT WITHOUT_BLKID)
    find_package(BLKID)
endif()

find_package(CPPHOCON REQUIRED)

if ("${CMAKE_SYSTEM_NAME}" MATCHES "Linux")
    find_package(UDEV)
endif()

find_package(WHEREAMI)
if (WHEREAMI_FOUND)
    add_definitions(-DUSE_WHEREAMI)
endif()

if (NOT WITHOUT_JRUBY AND NOT WIN32)
    find_package(JNI)
    set_package_properties(JNI PROPERTIES DESCRIPTION "Java Native Interface (JNI) is a programming framework that enables Java code running in a Java Virtual Machine (JVM) to call and be called by native applications.")
    set_package_properties(JNI PROPERTIES TYPE OPTIONAL PURPOSE "Enables JRuby support in Facter.")

    if (JNI_FOUND)
        find_package(Java)
        set_package_properties(Java PROPERTIES DESCRIPTION "Java compiler for JNI.")
        set_package_properties(Java PROPERTIES TYPE OPTIONAL PURPOSE "Enables JRuby support in Facter.")

        if (Java_JAVAC_EXECUTABLE)
            set(JRUBY_SUPPORT TRUE)
            set(CMAKE_JAVA_COMPILE_FLAGS -source 1.6 -target 1.6)
            add_definitions(-DUSE_JRUBY_SUPPORT)
        endif()
    endif()
endif()

# Display a summary of the features
include(FeatureSummary)
feature_summary(WHAT ALL)

# Set RPATH if not installing to a system library directory
list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" INSTALL_IS_SYSTEM_DIR)
if ("${INSTALL_IS_SYSTEM_DIR}" STREQUAL "-1")
    set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
endif()

# Pull in common cflags setting from leatherman
include(cflags)
set(FACTER_CXX_FLAGS "${LEATHERMAN_CXX_FLAGS}")
add_definitions(${LEATHERMAN_DEFINITIONS})

option(DYNAMICBASE "Add dynamicbase linker option" ON)
# Enable DEP/ASLR switches on windows versions
if (WIN32)
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--nxcompat")
      if (DYNAMICBASE)
        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--dynamicbase")
      endif()
endif()

#
# Add cpplint and cppcheck targets
#
file(GLOB_RECURSE ALL_SOURCES lib/src/*.cc lib/inc/*.hpp lib/inc/*.h exe/*.cc exe/*.hpp exe/*.h)
add_cpplint_files(${ALL_SOURCES})
enable_cpplint()

add_cppcheck_dirs("${PROJECT_SOURCE_DIR}/lib" "${PROJECT_SOURCE_DIR}/exe")
enable_cppcheck()

# Pull in helper macros for working with leatherman libraries
include(leatherman)

set(CMAKE_REQUIRED_FLAGS "-std=c++11")
set(CMAKE_REQUIRED_LIBRARIES ${LEATHERMAN_LIBRARIES})
set(CMAKE_REQUIRED_INCLUDES ${LEATHERMAN_INCLUDE_DIRS})

# Guards to make sure we don't compile what we don't have in Leatherman
CHECK_CXX_SOURCE_COMPILES("
#include <leatherman/util/environment.hpp>
int main() {
    int a = leatherman::util::environment::get_int(\"A\", 1000);
    return 0;
}
" HAS_LTH_GET_INT)

if (HAS_LTH_GET_INT)
    add_definitions(-DHAS_LTH_GET_INT)
endif()

CHECK_CXX_SOURCE_COMPILES("
#include \"leatherman/execution/execution.hpp\"

using namespace leatherman::execution;
using namespace std;
int main() {
    vector<string> paths;
    expand_command(\"command\", paths, false);
    return 0;
}
" HAS_LTH_EXPAND)

if (HAS_LTH_EXPAND)
  add_definitions(-DHAS_LTH_EXPAND)
endif()
if (WIN32)
    CHECK_CXX_SOURCE_COMPILES("
    #include \"leatherman/windows/registry.hpp\"

    using namespace leatherman::windows;
    int main() {
		int test = 0;
        try {
            test = registry::get_registry_dword(registry::HKEY::LOCAL_MACHINE, \"RandomSubkey\", \"RandomValue\");
        } catch (registry_exception &e) {
            return test;
        }
    }
    " HAS_LTH_GET_DWORD)

    if (HAS_LTH_GET_DWORD)
        add_definitions(-DHAS_LTH_GET_DWORD)
    endif()
endif()

add_subdirectory(lib)
add_subdirectory(exe)
add_subdirectory(locales)

# Add test executables for unit testing
add_test(NAME "libfacter\\ tests" COMMAND libfacter_test)
if (RUBY_FOUND)
    find_program(BUNDLER_PATH NAMES bundle.bat bundle)
    if (BUNDLER_PATH)
        message(STATUS "Bundler found, installing dependencies for Ruby tests...")
        execute_process(COMMAND ${BUNDLER_PATH} install --retry 2 --path=vendor/bundle WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}/lib")
        add_test(NAME "libfacter\\ specs" COMMAND ${BUNDLER_PATH} exec rspec WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}/lib")
    endif()
endif()
add_test(NAME "facter\\ smoke" COMMAND facter)

# Install the man page
if ("${CMAKE_SYSTEM_NAME}" MATCHES "OpenBSD|FreeBSD")
    set(MANDIR man/man8/)
else()
    set(MANDIR share/man/man8/)
endif()

option(INSTALL_BATCH_FILES "Generate .bat files during installation" ON)
install(FILES ${PROJECT_SOURCE_DIR}/man/man8/facter.8 DESTINATION ${MANDIR})
if (WIN32 AND INSTALL_BATCH_FILES)
  install(FILES ${PROJECT_SOURCE_DIR}/ext/windows/facter.bat DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)
  install(FILES ${PROJECT_SOURCE_DIR}/ext/windows/facter_interactive.bat DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)
  install(FILES ${PROJECT_SOURCE_DIR}/ext/windows/run_facter_interactive.bat DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)
endif()

=== lib/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2.2)

# Get the HEAD SHA1 commit message
get_commit_string(LIBFACTER_COMMIT)

# Generate a file containing the above version numbers
configure_file (
    "version.h.in"
    "${CMAKE_CURRENT_LIST_DIR}/inc/facter/version.h"
)

# Generate a .gemspec file based on the above version numbers
configure_file (
    "gemspec.in"
    "${CMAKE_CURRENT_LIST_DIR}/../.gemspec"
)

# Set compiler-specific flags
set(CMAKE_CXX_FLAGS ${FACTER_CXX_FLAGS})
if (WIN32)
    # Disable unused-variable variable for boost ipv6 compilation on windows
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-variable")
endif()

leatherman_logging_namespace("puppetlabs.facter")

# Set the common (platform-independent) sources
set(LIBFACTER_COMMON_SOURCES
    "src/cwrapper.cc"
    "src/facts/array_value.cc"
    "src/facts/collection.cc"
    "src/facts/external_resolvers_factory.cc"
    "src/facts/external/execution_resolver.cc"
    "src/facts/external/json_resolver.cc"
    "src/facts/external/resolver.cc"
    "src/facts/external/text_resolver.cc"
    "src/facts/external/yaml_resolver.cc"
    "src/facts/map_value.cc"
    "src/facts/resolver.cc"
    "src/facts/resolvers/augeas_resolver.cc"
    "src/facts/resolvers/disk_resolver.cc"
    "src/facts/resolvers/dmi_resolver.cc"
    "src/facts/resolvers/ec2_resolver.cc"
    "src/facts/resolvers/filesystem_resolver.cc"
    "src/facts/resolvers/fips_resolver.cc"
    "src/facts/resolvers/gce_resolver.cc"
    "src/facts/resolvers/hypervisors_resolver.cc"
    "src/facts/resolvers/identity_resolver.cc"
    "src/facts/resolvers/kernel_resolver.cc"
    "src/facts/resolvers/ldom_resolver.cc"
    "src/facts/resolvers/load_average_resolver.cc"
    "src/facts/resolvers/memory_resolver.cc"
    "src/facts/resolvers/networking_resolver.cc"
    "src/facts/resolvers/operating_system_resolver.cc"
    "src/facts/resolvers/path_resolver.cc"
    "src/facts/resolvers/processor_resolver.cc"
    "src/facts/resolvers/ruby_resolver.cc"
    "src/facts/resolvers/ssh_resolver.cc"
    "src/facts/resolvers/system_profiler_resolver.cc"
    "src/facts/resolvers/timezone_resolver.cc"
    "src/facts/resolvers/uptime_resolver.cc"
    "src/facts/resolvers/virtualization_resolver.cc"
    "src/facts/resolvers/xen_resolver.cc"
    "src/facts/resolvers/zpool_resolver.cc"
    "src/facts/resolvers/zone_resolver.cc"
    "src/facts/resolvers/zfs_resolver.cc"
    "src/facts/cache.cc"
    "src/facts/scalar_value.cc"
    "src/logging/logging.cc"
    "src/ruby/aggregate_resolution.cc"
    "src/ruby/chunk.cc"
    "src/ruby/confine.cc"
    "src/ruby/fact.cc"
    "src/ruby/module.cc"
    "src/ruby/resolution.cc"
    "src/ruby/ruby.cc"
    "src/ruby/ruby_value.cc"
    "src/ruby/simple_resolution.cc"
    "src/util/scoped_file.cc"
    "src/util/string.cc"
    "src/util/config/config.cc"
    "src/util/yaml.cc"
)

# Set the POSIX sources if on a POSIX platform
if (UNIX)
    set(LIBFACTER_STANDARD_SOURCES
        "src/facts/posix/collection.cc"
        "src/facts/posix/external_resolvers_factory.cc"
        "src/facts/posix/identity_resolver.cc"
        "src/facts/posix/networking_resolver.cc"
        "src/facts/posix/operatingsystem_resolver.cc"
        "src/facts/posix/processor_resolver.cc"
        "src/facts/posix/ssh_resolver.cc"
        "src/facts/posix/timezone_resolver.cc"
        "src/facts/posix/uptime_resolver.cc"
        "src/facts/posix/xen_resolver.cc"
        "src/facts/posix/cache.cc"
        "src/util/posix/scoped_addrinfo.cc"
        "src/util/posix/scoped_descriptor.cc"
        "src/util/config/posix/config.cc"
    )

    if (HAVE_UTMPX_H)
        set(LIBFACTER_STANDARD_SOURCES ${LIBFACTER_STANDARD_SOURCES} "src/util/posix/utmpx_file.cc")
    endif()

    if (NOT AIX)
        set(LIBFACTER_STANDARD_SOURCES
            ${LIBFACTER_STANDARD_SOURCES}
            "src/facts/posix/kernel_resolver.cc"
        )
    endif()
endif()

if (WIN32)
    set(LIBFACTER_STANDARD_SOURCES
        "src/facts/external/windows/powershell_resolver.cc"
        "src/facts/windows/collection.cc"
        "src/facts/windows/external_resolvers_factory.cc"
        "src/util/windows/wsa.cc"
    )
endif()

if (OPENSSL_FOUND)
    set(LIBFACTER_STANDARD_SOURCES ${LIBFACTER_STANDARD_SOURCES} "src/util/scoped_bio.cc")
endif()

# Set the platform-specific sources
if (AIX)
    set(LIBFACTER_PLATFORM_SOURCES
        "src/facts/aix/collection.cc"
        "src/facts/aix/disk_resolver.cc"
        "src/facts/aix/filesystem_resolver.cc"
        "src/facts/aix/kernel_resolver.cc"
        "src/facts/aix/load_average_resolver.cc"
        "src/facts/aix/memory_resolver.cc"
        "src/facts/aix/networking_resolver.cc"
        "src/facts/aix/nim_resolver.cc"
        "src/facts/aix/operating_system_resolver.cc"
        "src/facts/aix/processor_resolver.cc"
        "src/facts/aix/serial_number_resolver.cc"
    )

    set(LIBFACTER_PLATFORM_LIBRARIES
        odm
        lvm
    )
elseif ("${CMAKE_SYSTEM_NAME}" MATCHES "Darwin")
    set(LIBFACTER_PLATFORM_SOURCES
        "src/facts/bsd/filesystem_resolver.cc"
        "src/facts/bsd/networking_resolver.cc"
        "src/facts/bsd/uptime_resolver.cc"
        "src/facts/glib/load_average_resolver.cc"
        "src/facts/osx/dmi_resolver.cc"
        "src/facts/osx/networking_resolver.cc"
        "src/facts/osx/collection.cc"
        "src/facts/osx/memory_resolver.cc"
        "src/facts/osx/operating_system_resolver.cc"
        "src/facts/osx/processor_resolver.cc"
        "src/facts/osx/system_profiler_resolver.cc"
        "src/facts/osx/virtualization_resolver.cc"
        "src/util/bsd/scoped_ifaddrs.cc"
    )
elseif ("${CMAKE_SYSTEM_NAME}" MATCHES "SunOS")
    set(LIBFACTER_PLATFORM_SOURCES
        "src/facts/glib/load_average_resolver.cc"
        "src/facts/solaris/collection.cc"
        "src/facts/solaris/disk_resolver.cc"
        "src/facts/solaris/processor_resolver.cc"
        "src/facts/solaris/operating_system_resolver.cc"
        "src/facts/solaris/kernel_resolver.cc"
        "src/facts/solaris/filesystem_resolver.cc"
        "src/facts/solaris/dmi_resolver.cc"
        "src/facts/solaris/virtualization_resolver.cc"
        "src/facts/solaris/networking_resolver.cc"
        "src/facts/solaris/memory_resolver.cc"
        "src/facts/solaris/zfs_resolver.cc"
        "src/facts/solaris/zone_resolver.cc"
        "src/facts/solaris/zpool_resolver.cc"
        "src/facts/solaris/ldom_resolver.cc"
        "src/util/solaris/k_stat.cc"
        "src/util/solaris/scoped_kstat.cc"
    )
    set(LIBFACTER_PLATFORM_LIBRARIES
        kstat
        socket
        nsl
        rt
    )
elseif ("${CMAKE_SYSTEM_NAME}" MATCHES "Linux")
    set(LIBFACTER_PLATFORM_SOURCES
        "src/facts/bsd/networking_resolver.cc"
        "src/facts/glib/load_average_resolver.cc"
        "src/facts/linux/disk_resolver.cc"
        "src/facts/linux/dmi_resolver.cc"
        "src/facts/linux/filesystem_resolver.cc"
        "src/facts/linux/fips_resolver.cc"
        "src/facts/linux/kernel_resolver.cc"
        "src/facts/linux/memory_resolver.cc"
        "src/facts/linux/networking_resolver.cc"
        "src/facts/linux/operating_system_resolver.cc"
        "src/facts/linux/os_linux.cc"
        "src/facts/linux/uptime_resolver.cc"
        "src/facts/linux/collection.cc"
        "src/facts/linux/processor_resolver.cc"
        "src/facts/linux/virtualization_resolver.cc"
        "src/util/bsd/scoped_ifaddrs.cc"
    )
    set(LIBFACTER_PLATFORM_LIBRARIES
        ${BLKID_LIBRARIES}
        rt
        ${UDEV_LIBRARIES}
    )
elseif ("${CMAKE_SYSTEM_NAME}" MATCHES "FreeBSD")
    set(LIBFACTER_PLATFORM_SOURCES
        "src/facts/freebsd/collection.cc"
        "src/facts/glib/load_average_resolver.cc"
        "src/facts/bsd/filesystem_resolver.cc"
        "src/facts/freebsd/filesystem_resolver.cc"
        "src/facts/bsd/networking_resolver.cc"
        "src/facts/bsd/uptime_resolver.cc"
        "src/facts/freebsd/processor_resolver.cc"
        "src/facts/freebsd/dmi_resolver.cc"
        "src/facts/freebsd/networking_resolver.cc"
        "src/util/bsd/scoped_ifaddrs.cc"
        "src/facts/freebsd/zfs_resolver.cc"
        "src/facts/freebsd/zpool_resolver.cc"
        "src/facts/freebsd/virtualization_resolver.cc"
        "src/facts/freebsd/memory_resolver.cc"
        "src/facts/freebsd/operating_system_resolver.cc"
        "src/util/freebsd/geom.cc"
        "src/facts/freebsd/disk_resolver.cc"
    )
    set(LIBFACTER_PLATFORM_LIBRARIES
        geom
    )
elseif ("${CMAKE_SYSTEM_NAME}" MATCHES "OpenBSD")
    set(LIBFACTER_PLATFORM_SOURCES
        "src/facts/openbsd/collection.cc"
        "src/facts/glib/load_average_resolver.cc"
        "src/facts/bsd/filesystem_resolver.cc"
        "src/facts/bsd/networking_resolver.cc"
        "src/facts/bsd/uptime_resolver.cc"
        "src/facts/openbsd/dmi_resolver.cc"
        "src/facts/openbsd/networking_resolver.cc"
        "src/facts/openbsd/processor_resolver.cc"
        "src/util/bsd/scoped_ifaddrs.cc"
        "src/facts/openbsd/memory_resolver.cc"
        "src/facts/openbsd/virtualization_resolver.cc"
    )
elseif ("${CMAKE_SYSTEM_NAME}" MATCHES "Windows")
    set(LIBFACTER_PLATFORM_SOURCES
        "src/facts/windows/dmi_resolver.cc"
        "src/facts/windows/identity_resolver.cc"
        "src/facts/windows/kernel_resolver.cc"
        "src/facts/windows/memory_resolver.cc"
        "src/facts/windows/networking_resolver.cc"
        "src/facts/windows/ssh_resolver.cc"
        "src/facts/windows/operating_system_resolver.cc"
        "src/facts/windows/processor_resolver.cc"
        "src/facts/windows/timezone_resolver.cc"
        "src/facts/windows/uptime_resolver.cc"
        "src/facts/windows/virtualization_resolver.cc"
        "src/facts/windows/cache.cc"
        "src/util/config/windows/config.cc"
    )

    if (HAS_LTH_GET_DWORD)
        set(LIBFACTER_PLATFORM_SOURCES
            ${LIBFACTER_PLATFORM_SOURCES}
            "src/facts/windows/fips_resolver.cc"
        )
    endif()
    # The GetPerformanceInfo symbol has moved around a lot between Windows versions;
    # these options tie it to the backwards-compatible version.
    set(LIBFACTER_PLATFORM_LIBRARIES
        Psapi.lib
        Version.lib
        Wbemuuid.lib
        Secur32.lib
        Ws2_32.lib
        iphlpapi.lib
        userenv.lib
    )
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DPSAPI_VERSION=1")
endif()

if (WIN32)
    set(LIBFACTER_INSTALL_DESTINATION bin)
else()
    set(LIBFACTER_INSTALL_DESTINATION lib${LIB_SUFFIX})
endif()

if (JRUBY_SUPPORT)
    include_directories(${JNI_INCLUDE_DIRS})
    set(LIBFACTER_COMMON_SOURCES ${LIBFACTER_COMMON_SOURCES} src/java/facter.cc)

    configure_file(
        Facter.java.in
        "${CMAKE_BINARY_DIR}/lib/com/puppetlabs/Facter.java"
    )

    include(UseJava)
    add_jar(facter-jruby-jar "${CMAKE_BINARY_DIR}/lib/com/puppetlabs/Facter.java" OUTPUT_NAME facter OUTPUT_DIR "${CMAKE_BINARY_DIR}/lib" ENTRY_POINT com/puppetlabs/Facter)

    # javah does not atomically write the header file, so parallel builds can
    # read it before it finishes writing if not careful.
    # JDK versions after 9 don't provide javah. Use javac in these cases

    if(Java_VERSION VERSION_LESS "10")
	    set(JAVAH_COMMAND ${Java_JAVAH_EXECUTABLE})
	    set(JAVAH_ARG -classpath facter.jar -d "${CMAKE_CURRENT_LIST_DIR}/src/java" com.puppetlabs.Facter)
    else()
	    set(JAVAH_COMMAND ${Java_JAVAC_EXECUTABLE})
	    set(JAVAH_ARG -h  "${CMAKE_CURRENT_LIST_DIR}/src/java" com/puppetlabs/Facter.java)
    endif()

    add_custom_command(OUTPUT "${CMAKE_CURRENT_LIST_DIR}/src/java/com_puppetlabs_Facter.h"
                       COMMAND ${JAVAH_COMMAND} ARGS ${JAVAH_ARG}
                       WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/lib"
                       DEPENDS facter-jruby-jar)
    # Anything that depends on facter-jruby wants both the jar AND the completely written header.

=== locales/CMakeLists.txt ===
if (NOT WIN32)
    gettext_templates(${CMAKE_CURRENT_SOURCE_DIR} ${ALL_SOURCES})
    gettext_compile(${CMAKE_CURRENT_SOURCE_DIR} share/locale)
    SET_DIRECTORY_PROPERTIES(PROPERTIES CLEAN_NO_CUSTOM TRUE)
    export_var(GETTEXT_ENABLED)
endif()

=== lib/tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2.2)

find_package(Ruby 1.9)

# Set the common (platform-independent) sources
set(LIBFACTER_TESTS_COMMON_SOURCES
    "facts/array_value.cc"
    "facts/boolean_value.cc"
    "facts/double_value.cc"
    "facts/external/json_resolver.cc"
    "facts/external/text_resolver.cc"
    "facts/external/yaml_resolver.cc"
    "facts/collection.cc"
    "facts/external_resolvers_factory.cc"
    "facts/integer_value.cc"
    "facts/map_value.cc"
    "facts/resolvers/augeas_resolver.cc"
    "facts/resolvers/disk_resolver.cc"
    "facts/resolvers/dmi_resolver.cc"
    "facts/resolvers/filesystem_resolver.cc"
    "facts/resolvers/identity_resolver.cc"
    "facts/resolvers/kernel_resolver.cc"
    "facts/resolvers/ldom_resolver.cc"
    "facts/resolvers/memory_resolver.cc"
    "facts/resolvers/networking_resolver.cc"
    "facts/resolvers/operating_system_resolver.cc"
    "facts/resolvers/processor_resolver.cc"
    "facts/resolvers/ruby_resolver.cc"
    "facts/resolvers/ssh_resolver.cc"
    "facts/resolvers/system_profiler_resolver.cc"
    "facts/resolvers/timezone_resolver.cc"
    "facts/resolvers/uptime_resolver.cc"
    "facts/resolvers/virtualization_resolver.cc"
    "facts/resolvers/xen_resolver.cc"
    "facts/resolvers/zfs_resolver.cc"
    "facts/resolvers/zone_resolver.cc"
    "facts/resolvers/zpool_resolver.cc"
    "facts/schema.cc"
    "facts/cache.cc"
    "facts/string_value.cc"
    "logging/logging.cc"
    "log_capture.cc"
    "main.cc"
    "mock_server.cc"
    "util/string.cc"
    "fixtures.cc"
    "collection_fixture.cc"
    "cwrapper.cc"
)

# Set compiler-specific flags
set(CMAKE_CXX_FLAGS ${FACTER_CXX_FLAGS})

# Add the ruby tests if there's a ruby installed
if (RUBY_FOUND)
    set(LIBFACTER_TESTS_COMMON_SOURCES
        ${LIBFACTER_TESTS_COMMON_SOURCES}
        "ruby/ruby.cc"
        "ruby/ruby_dirfacts.cc"
        "ruby/ruby_helper.cc")

    if (WIN32)
        set(LIBFACTER_TESTS_COMMON_SOURCES
            ${LIBFACTER_TESTS_COMMON_SOURCES}
            "ruby/windows/ruby.cc")
    endif()
endif()

# Set the POSIX sources if on a POSIX platform
if (UNIX)
    set(LIBFACTER_TESTS_CATEGORY_SOURCES
        "facts/posix/collection.cc"
        "facts/posix/external_resolvers_factory.cc"
        "facts/posix/uptime_resolver.cc"
        "facts/external/posix/execution_resolver.cc"
        "util/posix/scoped_addrinfo.cc"
        "util/posix/scoped_descriptor.cc"
    )
    set(POSIX_TESTS_LIBRARIES ${POSIX_LIBRARIES})
endif()

set(LIBFACTER_TESTS_PLATFORM_LIBRARIES
    ${LIBFACTER_PLATFORM_LIBRARIES}
)

if (WIN32)
    list(APPEND LIBFACTER_TESTS_PLATFORM_LIBRARIES Mswsock)
    set(LIBFACTER_TESTS_CATEGORY_SOURCES
        "facts/windows/collection.cc"
        "facts/windows/external_resolvers_factory.cc"
        "facts/windows/networking_resolver.cc"
        "facts/windows/operating_system_resolver.cc"
        "facts/external/windows/execution_resolver.cc"
        "facts/external/windows/powershell_resolver.cc"
    )
endif()

if (OPENSSL_FOUND)
    set(LIBFACTER_TESTS_CATEGORY_SOURCES ${LIBFACTER_TESTS_CATEGORY_SOURCES} "util/scoped_bio.cc")
endif()

# Set the platform-specific sources
if ("${CMAKE_SYSTEM_NAME}" MATCHES "Darwin")
    set(LIBFACTER_TESTS_PLATFORM_SOURCES
        "util/bsd/scoped_ifaddrs.cc"
    )
elseif ("${CMAKE_SYSTEM_NAME}" MATCHES "Linux")
    set(LIBFACTER_TESTS_PLATFORM_SOURCES
        "facts/linux/dmi_resolver.cc"
        "facts/linux/filesystem_resolver.cc"
        "facts/linux/virtualization_resolver.cc"
        "facts/linux/processor_fixture.cc"
        "facts/linux/processor_resolver.cc"
        "util/bsd/scoped_ifaddrs.cc"
    )
endif()

if (JRUBY_SUPPORT)
    include_directories(${JNI_INCLUDE_DIRS})
    set(LIBFACTER_TESTS_COMMON_SOURCES ${LIBFACTER_TESTS_COMMON_SOURCES} java/facter.cc)
endif()

include_directories(
    ../inc
    ${Boost_INCLUDE_DIRS}
    ${OPENSSL_INCLUDE_DIRS}
    ${YAMLCPP_INCLUDE_DIRS}
    ${LEATHERMAN_CATCH_INCLUDE}
    ${CPPHOCON_INCLUDE_DIRS}
)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated-declarations")
if (WIN32)
    # On Windows with GCC 5.2, Boost.System emits warnings that aren't correctly
    # suppressed by pragmas. Explicitly skip them.
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-variable")
endif()

add_executable(libfacter_test $<TARGET_OBJECTS:libfactersrc>
    ${LIBFACTER_TESTS_COMMON_SOURCES}
    ${LIBFACTER_TESTS_PLATFORM_SOURCES}
    ${LIBFACTER_TESTS_CATEGORY_SOURCES})
target_link_libraries(libfacter_test
    ${LIBS}
    ${LIBFACTER_TESTS_PLATFORM_LIBRARIES})

if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin" AND BOOST_STATIC AND LEATHERMAN_USE_LOCALES)
    target_link_libraries(libfacter_test iconv)
endif()

target_compile_definitions(libfacter_test PRIVATE "-Dlibfacter_EXPORTS")

# Generate a file containing the path to the fixtures
configure_file (
    "fixtures.hpp.in"
    "${CMAKE_CURRENT_LIST_DIR}/fixtures.hpp"
)

=== debian/changelog ===
facter (3.14.12-1) unstable; urgency=medium

  [ Utkarsh Gupta ]
  * New upstream version 3.14.9
  * Refresh d/patches

  [ Apollon Oikonomopoulos ]
  * New upstream version 3.14.12 (Closes: #962692, #970408)
    - Drop 0005-fix-custom-facts-overriding-core.patch; included upstream
    - Drop 0008-FACT-2018-update-gce-metadata-endpoint.patch; included upstream
    + Bump SONAME to libfacter3.14.12
  * Acknowledge the following NMUs:
    + 3.11.0-4.1; thanks to Antonio Terceiro (Closes: #956641)
    + 3.11.0-4.2; thanks to Sebastian Ramacher
    + 4.11.0-4.3; thanks to Sven Hoexter
      • Modify Sven's patch to use approximate matching for double tests,
        instead of picking initial values that are accurately represented in
        IEEE 754.
  * Bump dh compat to 13
  * Bump Standards-Version to 4.5.0; no changes needed
  * d/copyright: bump debian/* years
  * Skip the filesystem fact tests, as they are unreliable in
    chroots/containers

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Sat, 19 Sep 2020 10:33:29 +0300

facter (3.11.0-4.3) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/patches: add 0008-FACT-2018-update-gce-metadata-endpoint.patch
    Switch Google GCE metadata endpoint from v1beta1 to final v1, the beta
    endpoint will be shutdown end of September 2020. (Closes: #966374)

 -- Sven Hoexter <hoexter@debian.org>  Tue, 28 Jul 2020 09:17:17 +0200

facter (3.11.0-4.2) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/patches: Fix tests with yaml-cpp 0.6.3 (Closes: #959573)

 -- Sebastian Ramacher <sramacher@debian.org>  Wed, 17 Jun 2020 23:21:32 +0200

facter (3.11.0-4.1) unstable; urgency=medium

  * Non-maintainer upload
  * Add patch to not fail build when bundler is installed (Closes: #956300)
  * Add a dependency on the minimal Ruby version needed (Closes: #956301)

 -- Antonio Terceiro <terceiro@debian.org>  Mon, 13 Apr 2020 16:45:20 -0300

=== debian/control ===
Source: facter
Section: admin
Priority: optional
Maintainer: Puppet Package Maintainers <pkg-puppet-devel@lists.alioth.debian.org>
Uploaders:
 Andrew Pollock <apollock@debian.org>,
 Micah Anderson <micah@debian.org>,
 Stig Sandbeck Mathisen <ssm@debian.org>,
 Apollon Oikonomopoulos <apoikos@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 catch,
 libblkid-dev,
 libboost-program-options-dev,
 libboost-system-dev,
 libboost-filesystem-dev,
 libboost-date-time-dev,
 libboost-regex-dev,
 libboost-thread-dev,
 libboost-chrono-dev,
 libboost-locale-dev,
 libboost-log-dev,
 libleatherman-dev,
 libcpp-hocon-dev,
 libcurl4-openssl-dev,
 libyaml-cpp-dev,
 libssl-dev,
 rapidjson-dev,
 ruby-all-dev,
 ruby,
Standards-Version: 4.5.0
Vcs-Git: https://salsa.debian.org/puppet-team/facter.git
Vcs-Browser: https://salsa.debian.org/puppet-team/facter
Homepage: https://github.com/puppetlabs/facter

Package: facter
Architecture: any
Depends: libfacter3.14.12 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}, ${ruby-interpreter:Depends}
Description: collect and display facts about the system
 Facter is Puppet’s cross-platform system profiling library. It discovers and
 reports per-node facts, which are collected by the Puppet agent and are made
 available in Puppet manifests as variables. Facter comes with a number of
 built-in facts providing information about the operating system, hardware, SSH
 keys, etc., but is also easily extensible through the following interfaces:
 .
  * Through custom facts using Facter's Ruby API.
  * Through `external' facts which can be either executables, or static data
    files.
 .
 This package contains the facter binary and the ruby module making facter
 available to Puppet.

Package: libfacter3.14.12
Architecture: any
Section: libs
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: collect and display facts about the system -- shared library
 Facter is Puppet’s cross-platform system profiling library. It discovers and
 reports per-node facts, which are collected by the Puppet agent and are made
 available in Puppet manifests as variables. Facter comes with a number of
 built-in facts providing information about the operating system, hardware, SSH
 keys, etc., but is also easily extensible through the following interfaces:
 .
  * Through custom facts using Facter's Ruby API.
  * Through `external' facts which can be either executables, or static data
    files.
 .
 This package contains the core shared library implementing most of Facter's
 functionality.

Package: facter-dev
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libfacter3.14.12 (= ${binary:Version})
Description: collect and display facts about the system -- development files
 Facter is Puppet’s cross-platform system profiling library. It discovers and
 reports per-node facts, which are collected by the Puppet agent and are made
 available in Puppet manifests as variables. Facter comes with a number of
 built-in facts providing information about the operating system, hardware, SSH
 keys, etc., but is also easily extensible through the following interfaces:
 .
  * Through custom facts using Facter's Ruby API.
  * Through `external' facts which can be either executables, or static data
    files.
 .
 This package contains development files allowing 3rd party applications to use
 facter.

=== debian/tests/control ===
Tests: run
Restrictions: allow-stderr
Depends: @

Tests: ruby
Restrictions: allow-stderr
Depends: facter, ruby

Tests: puppet
Restrictions: allow-stderr
Depends: facter, puppet

=== debian/watch ===
version=3
opts=\
uversionmangle=s{(.*(?:alpha|beta|rc).*)}{~$1},\
pgpsigurlmangle=s/$/.asc/ \
https://downloads.puppetlabs.com/facter/facter-(\S+)\.tar\.gz

## facter 4.2.13

=== debian/changelog ===
facter (4.2.13-2) unstable; urgency=medium

  * replace install.rb with dh ruby buildsystem (Closes: #978500)

 -- Jérôme Charaoui <jerome@riseup.net>  Thu, 13 Oct 2022 15:43:58 -0400

facter (4.2.13-1) unstable; urgency=medium

  [ Jérôme Charaoui ]
  * New upstream version 4.2.13
  * d/rules: revert to packaging facter as a Ruby gem
  * d/control:
    + adapt build-deps for ruby build
    + bump Standards-Version, no changes needed
    + add myself to Uploaders
    + reintroduce previous Recommends
    - relax ruby dep, remove gencontrol script
    - drop shared library and dev packages
  * d/copyright: update copyrights
  * d/patches: drop C++ patches, add fix for install.rb
  * d/tests: use new puppet agent package name
  * d/watch: switch to git mode
  * d/NEWS: add entry for 4.2.13-1 release

  [ Micah Anderson ]
  * Remove myself from debian/control Uploaders field

 -- Jérôme Charaoui <jerome@riseup.net>  Thu, 13 Oct 2022 09:31:15 -0400

facter (3.14.12-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rebuild for Ruby 3.0.
  * d/control (Build-Depends): Make sure to build against libleatherman-dev
    version fixed to build with GCC 11.
  * d/gen-ruby-dependency: Fix dependency creation.

 -- Daniel Leidert <dleidert@debian.org>  Sat, 04 Dec 2021 07:45:47 +0100

=== debian/control ===
Source: facter
Section: admin
Priority: optional
Maintainer: Puppet Package Maintainers <pkg-puppet-devel@lists.alioth.debian.org>
Uploaders:
 Andrew Pollock <apollock@debian.org>,
 Stig Sandbeck Mathisen <ssm@debian.org>,
 Apollon Oikonomopoulos <apoikos@debian.org>,
 Jérôme Charaoui <jerome@riseup.net>,
Build-Depends:
 debhelper-compat (= 13),
 gem2deb,
Standards-Version: 4.6.1
Vcs-Git: https://salsa.debian.org/puppet-team/facter.git
Vcs-Browser: https://salsa.debian.org/puppet-team/facter
Homepage: https://github.com/puppetlabs/facter
XS-Ruby-Versions: all

Package: facter
Architecture: all
XB-Ruby-Versions: ${ruby:Versions}
Depends:
 ${ruby:Depends},
 ${misc:Depends},
Recommends: pciutils, dmidecode, virt-what
Description: collect and display facts about the system
 Facter is Puppet’s cross-platform system profiling library. It discovers and
 reports per-node facts, which are collected by the Puppet agent and are made
 available in Puppet manifests as variables. Facter comes with a number of
 built-in facts providing information about the operating system, hardware, SSH
 keys, etc., but is also easily extensible through the following interfaces:
 .
  * Through custom facts using Facter's Ruby API.
  * Through `external' facts which can be either executables, or static data
    files.
 .
 This package contains the facter binary and the ruby module making facter
 available to Puppet.

=== debian/tests/control ===
--- 
+++ 
@@ -8,4 +8,4 @@
 
 Tests: puppet
 Restrictions: allow-stderr
-Depends: facter, puppet
+Depends: facter, puppet-agent

## facter 4.3.0

=== debian/changelog ===
facter (4.3.0-2) unstable; urgency=medium

  * d/control: add ruby-sys-filesystem to Recommends
  * d/control: remove obsolete X*-Ruby-Versions fields
  * d/patches: add patch to fix paths for debian
  * d/patches: add patch to improve manpage
  * d/tests: test config file, external facts and cache

 -- Jérôme Charaoui <jerome@riseup.net>  Wed, 22 Feb 2023 15:41:04 -0500

facter (4.3.0-1) unstable; urgency=medium

  * New upstream version 4.3.0
  * d/control: bump Standards-Version, no changes needed
  * d/control: add Rules-Requires-Root: no

 -- Jérôme Charaoui <jerome@riseup.net>  Fri, 10 Feb 2023 14:36:38 -0500

=== debian/control ===
--- 
+++ 
@@ -10,19 +10,22 @@
 Build-Depends:
  debhelper-compat (= 13),
  gem2deb,
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Git: https://salsa.debian.org/puppet-team/facter.git
 Vcs-Browser: https://salsa.debian.org/puppet-team/facter
 Homepage: https://github.com/puppetlabs/facter
-XS-Ruby-Versions: all
+Rules-Requires-Root: no
 
 Package: facter
 Architecture: all
-XB-Ruby-Versions: ${ruby:Versions}
 Depends:
+ ${misc:Depends},
  ${ruby:Depends},
- ${misc:Depends},
-Recommends: pciutils, dmidecode, virt-what
+Recommends:
+ dmidecode,
+ pciutils,
+ ruby-sys-filesystem,
+ virt-what,
 Description: collect and display facts about the system
  Facter is Puppet’s cross-platform system profiling library. It discovers and
  reports per-node facts, which are collected by the Puppet agent and are made

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# export DH_VERBOSE=1
# export DH_RUBY_IGNORE_TESTS=all

%:
	dh $@ --buildsystem=ruby --with ruby

=== debian/tests/control ===
Tests: run
Restrictions: allow-stderr, needs-root
Depends:
 @,

Tests: ruby
Restrictions: allow-stderr
Depends:
 facter,
 ruby,

Tests: puppet
Restrictions: allow-stderr
Depends:
 facter,
 puppet-agent,

=== debian/watch ===
version=4
opts="mode=git" \
https://github.com/puppetlabs/facter.git \
refs/tags/([\d\.]+)

## facter 4.6.1

=== debian/changelog ===
facter (4.6.1-1) unstable; urgency=medium

  [ Jérôme Charaoui ]
  * New upstream version 4.6.1 (Closes: #1026354)
  * d/patches: refresh for new upstream version
  * d/patches: fix patch hunk mixup
  * run spec tests during build

  [lintian-brush]
  * Trim trailing whitespace.
  * Use secure copyright file specification URI.
  * Remove obsolete field Name from debian/upstream/metadata (already present in
    machine-readable debian/copyright).

 -- Jérôme Charaoui <jerome@riseup.net>  Sat, 16 Mar 2024 09:15:50 -0400

=== debian/control ===
--- 
+++ 
@@ -10,6 +10,10 @@
 Build-Depends:
  debhelper-compat (= 13),
  gem2deb,
+ ruby-hocon <!nocheck>,
+ ruby-rspec <!nocheck>,
+ ruby-thor <!nocheck>,
+ ruby-webmock <!nocheck>,
 Standards-Version: 4.6.2
 Vcs-Git: https://salsa.debian.org/puppet-team/facter.git
 Vcs-Browser: https://salsa.debian.org/puppet-team/facter

## facter 4.8.0

=== debian/changelog ===
facter (4.8.0-1) unstable; urgency=medium

  * New upstream version 4.8.0
  * d/control: bump Standards-Version, no changes needed
  * d/patches: refresh patches for new upstream version
  * d/patches: new patch to relax ruby-thor dependency

 -- Jérôme Charaoui <jerome@riseup.net>  Fri, 30 Aug 2024 23:49:27 -0400

## facter 4.10.0

=== debian/changelog ===
facter (4.10.0-1) unstable; urgency=medium

  * New upstream version 4.10.0
  * d/tests: add gem dependency check
  * d/watch: switch to recommended github pattern

 -- Jérôme Charaoui <jerome@riseup.net>  Mon, 25 Nov 2024 20:13:06 -0500

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
  ruby-rspec <!nocheck>,
  ruby-thor <!nocheck>,
  ruby-webmock <!nocheck>,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Git: https://salsa.debian.org/puppet-team/facter.git
 Vcs-Browser: https://salsa.debian.org/puppet-team/facter
 Homepage: https://github.com/puppetlabs/facter

=== debian/rules ===
--- 
+++ 
@@ -6,4 +6,3 @@
 
 %:
 	dh $@ --buildsystem=ruby --with ruby
-

=== debian/tests/control ===
--- 
+++ 
@@ -14,3 +14,8 @@
 Depends:
  facter,
  puppet-agent,
+
+Test-Command: ruby -e "gem 'facter'"
+Features: test-name=gem
+Depends:
+ facter,

=== debian/watch ===
version=4
opts=\
filenamemangle=s%.*/@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,\
downloadurlmangle=s%(api.github.com/repos/[^/]+/[^/]+)/git/refs/%$1/tarball/refs/%g,\
searchmode=plain \
https://api.github.com/repos/puppetlabs/facter/git/matching-refs/tags/ \
https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/@ANY_VERSION@
